;**************************************************************************
;    RX_GEN_HT6P20B_V7.ASM
;
;    
;    RECEPTOR RF PARA CONTROLE REMOTOS (CHAVEIRINHOS) COM CI HT6P20B
; 
;    PARA DECODIFICAR UTILIZA UM PIC 12F629 (OPCIONALMENTE UM 12F675, DES-
;    COMENTANDO/COMENTANDO  AS LINHAS CITADAS NO TEXTO).
;
;    CLAUDIO LRIOS        INICIO: 27-07-2012  TERMINO:28-06-2012
;    REVISADO EM 18/09/2012 
;    VERSO 7:   
;    3 SAIDAS DE CONTROLE: LED1 (PINO 6) ,LED2 (PINO 5)  E LED3 ( PINO 3)
;    ACRESCENTADO OPO DE USUARIO: PULSO OU RETENO    
;    ANTES DE COMPILAR, ESCOLHAS SUAS DEFINIES ABAIXO (DEFINIES DE USUARIO)
;    O MODO DE APRENDIZADO FOI REFORMULADO: APENAS APRENDA UM BOTO, QUE OS OUTROS
;    J SERO ACEITOS.
;**************************************************************************
;
;   GRAVAR CONTROLE:  APERTE QUALQUER BOTO DO CONTROLE E MANTENHA APERTADO.
;   APERTE TAMBM O BOTO 'LEARN' NA PLACA (PINO 4 DO PIC 12F629  A MASSA)E 
;   SOLTE-O EM MENOS DE 1 SEGUNDOS.  O LED 'LEARN'(PINO 2)   PISCAR 1
;   VEZ, PARA INDICAR 'CODE APRENDIDO'. OS OUTROS BOTES J SERO APRENDIDOS.
;   APAGAR TODOS OS CONTROLES DA MEMRIA:  APERTAR BOTO 'LEARN' NA PLACA E 
;   MANTENHA PRESSIONADO POR MAIS DE 10 SEGUNDOS.    O LED 'LEARN' (PINO 2) PISCAR
;   3 VEZES , INDICANDO O PLENO APAGAMENTO DE TODOS OS SENSORES DA MEMRIA.
;   APS ISTO, CADA CONTROLE DEVER SER 'REAPRENDIDO' NOVAMENTE PARA OPERAR.
;*************************************************************************** 
;===================================================================================================================
;DEFINIES DO USUARIO (DESCOMENTE A OPO DESEJADA E COMENTE AS OUTRAS)

#DEFINE PIC_629     ;ESCOLHE MICROCONTROLADOR PIC12F629
;#DEFINE PIC_675    ;ESCOLHE MICROCONTROLADOR PIC12F675

; #DEFINE  PULSO     ;ACENDE ENQUANTO BOTO ESTIVER PRESSIONADO
#DEFINE  RETENO   ; UM TOQUE LIGA OUTRO TOQUE DESLIGA
;===================================================================================================================
    IFDEF PIC_675
	LIST P=12f675 , R=DEC
 	INCLUDE "P12F675.INC"
    ENDIF
    IFDEF PIC_629
 	LIST P=12f629 , R=DEC
 	INCLUDE "P12F629.INC"
    ENDIF
;--------------------------
	ERRORLEVEL      -302   
	__CONFIG		_CP_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_ON & _MCLRE_OFF


#DEFINE		BANK0	BCF	STATUS,RP0 	 ;SETA BANK0 DE MEMORIA
#DEFINE		BANK1	BSF	STATUS,RP0	 ;SETA BANK1
#DEFINE		FLAG	FLAGS,0          ;FLAG DE SITUAO
#DEFINE		FLAG1	FLAGS,1     	 ;FLAG DE NOVA LEITURA
#DEFINE		FLAGGR	FLAGS,2     	 ;FLAG DE 'LEARN' APRENDER

#DEFINE		FLAGLED1	FLAGS,3          ;FLAG DE SITUAO
#DEFINE		FLAGLED2	FLAGS,4     	 ;FLAG DE SITUAO
#DEFINE		FLAGLED3	FLAGS,5     	 ;FLAG DE SITUAO

#DEFINE SIN 		GPIO,0  ;PINO 7  IN RF
#DEFINE LRN  		GPIO,3	;PINO 4  IN LEARN BOTTON
#DEFINE LED  		GPIO,5  ;PINO 2  SAIDA LED 'LEARN'
#DEFINE LED2      	GPIO,2	;PINO 5- SAIDA DO LED2
#DEFINE LED1      	GPIO,1	;PINO 6- SAIDA DO LED1
#DEFINE LED3      	GPIO,4	;PINO 3- SAIDA DO LED3

     CBLOCK  0X20
 RES3,RES2,RES1,RES0,AUX,C3,C2,C1,C0,WS,TEMP,BITCOUNTER,FLAGS,TL0,TL1,TL2,Z2,Z1,Y1,Y2
  LcdDelayCounter,LcdDelayCounter1,tmpLcdRegister,tmpLcdRegister1,SITUAO
  temp,SDATA,AUX2 ,LC,HC ,CONT,RES3A,RES2A,RES1A,RES0A,X,R0,R1,R2,R3,TMP1,TMP2,TMP3,ADDRESS,TMP
     ENDC

WRCFG	EQU	B'00000000'	; PORTB: EEPROM WRITE TRI-STATE VALUE
YTRISA	EQU	B'001001'	; PORTA: TRI-STATE VALUE  
TMAX    EQU  .50       ;TEMPO MAXIMO DO SINAL LOW
QBYTE   EQU  .28        ;QUANTIDADE DE BYTES A SER RECEBIDO (22 ADRESS+ 2 DADO+ 4 ANTICODE)
TGR     EQU  .255       ;TEMPO DE BOTO APERTADO PARA APAGAR GRAVAAO

T_DESL_LED EQU .20     ;TEMPO MXIMO QUE LEDS FICAM ACESOS APS CESSAR TRANSMISSO

    ORG 0X00
    GOTO START
    ORG 0X04
    RETFIE

START:
	MOVLW   0X07
	MOVWF	CMCON			;DESLIGA COMPARADORES
	CLRF	GPIO			; RESET PORT
	MOVLW	YTRISA			; SETUP PORTA
	TRIS	GPIO

    IFDEF PIC_675
 	BANK1
 	MOVLW .0
 	MOVWF ANSEL  ;LIBERA PORTAS DO AD (SOMENTE 12f675)
    BANK0
    ENDIF

	 CLRF   FLAGS   ;APAGA REGISTRADOR DE FLAGS
     MOVLW  TGR
     MOVWF  Z2
     CLRF   Z1      ;LIMPA REGISTRADORES
INICIO:
    
     CLRF  RES3
     CLRF  RES2
     CLRF  RES1
	 CLRF  RES0
     MOVLW  QBYTE  ;PREPARA PARA A RECEPO COM NUMERO DE BITS A RECEBER
	 MOVWF  BITCOUNTER
     
L0
     BCF   FLAG   ;LIMPA FLAG E REGISTRADORES DE RECEPO
     CLRF  HC
     CLRF  LC
L1
;---------------------------------

     BTFSS  LRN   ;TESTA BOTO 'LEARN' APERTADO
     GOTO   TAPAGAMENTO  ;APERTADO, COMEA A CONTAR TEMPO MAX. DE APAGAMENTO
	 MOVLW  TGR
     MOVWF  Z2		;RECARGA DO TEMPO DE APAGAMENTO
     CLRF   Z1      ;LIMPA REGISTRADORES
L1H    
     GOTO    SS5

TAPAGAMENTO       ;APAGAR TODOS OS CONTROLES DA MEMRIA
     DECFSZ Z1,F
     GOTO   L1H  
     DECFSZ Z2,F
     GOTO   L1H
     CALL   APAGAEEPROM ;ATINGIU TEMPO MAXIMO: APAGAR MEMRIA
     MOVLW  .3         ;PISCA 3 VEZES
     MOVWF  AUX2
     BSF    LED        ;ACENDE LED (UMA PISCADA)
     MOVLW  .10
     CALL   DELAYM
     BCF    LED        ;APAGA LED
     MOVLW  .10
     CALL   DELAYM
     DECFSZ AUX2,F
     GOTO   $-7
     BTFSS  LRN       ;AGUARDA SOLTAR BOTO 'LEARN'
     GOTO   $-1
     GOTO INICIO

;===================ROTINA DE RECEPO==========================
SS5:
;A  
	 
     BTFSS FLAG        ;TESTA FLAG DE HUM/ZERO RECEBIDO
	 GOTO  L2      ;FLAG=0
;--------------------------------
;B
     BTFSS SIN      ;SIN ? TESTA SINAL DE ENTRADA DO RECEPTOR DE RF
	 GOTO  M0       ; SIN=0
;----------------------------------
L2
;C
	 BTFSS SIN      ;SIN ?
     GOTO  LA1      ;SIN=0
;-------------------------------------
;E
	 BSF   FLAG     ;SIN=1
     INCF  HC,F
     BTFSC STATUS,Z
     DECF  HC,F
     GOTO  LA2	   ;VAI CONTAR TEMPO DE 50 MICRO SEGUNDOS
;---------------------------------------------------------
LA1
;D
    INCF  LC,F     ;INCREMENTA REGISTRADOR DE LOW SIGNAL NA ENTRADA RF
    BTFSC STATUS,Z
    DECF  LC,F
LA2
    
     DECFSZ Y1,F    ;CONTADOR DE TEMPO DE DESLIGAMENTO DE SAIDAS
     GOTO   J0
    DECFSZ Y2,F    ;CONTADOR DE TEMPO DE DESLIGAMENTO DE SAIDAS
     GOTO   J0
     IFDEF  PULSO
     BCF   LED1    ;APAGA LEDS
     BCF   LED2
     BCF   LED3
     ENDIF
     IFDEF RETENO
     BCF FLAGLED3
     BCF FLAGLED2
     BCF FLAGLED1
     ENDIF
     INCF  Y1,F
     INCF  Y2,F
J0

	MOVLW  .9  ;.9 = 50 MICROSEG    (ACERTA TEMPO ENTRE LEITURAS DA ENTRADA DE RF)
    MOVWF  CONT
    DECFSZ CONT,F
    GOTO $-1
    GOTO L1




M0
;----------------------------------
;F
    MOVFW  LC		    ;TESTA SE NO PASSOU DO LIMITE MAXIMO DE TEMPO EM LOW NA ENTRADA DE RF
    SUBLW  TMAX
    BTFSS  STATUS,C
    GOTO   INICIO       ;C=0 (-)  -  LC>TMAX (REJEITAR DADO - PAUSA INICIAL)
;F'
 
;-----------------------------------
    
;G
    MOVFW  HC			;OBTEM O VALOR DE 'CARRY'(HUM OU ZERO)
    SUBWF  LC,W
    
    RRF    RES3,F       ;DESLOCA  O BIT NOS REGISTRADORES DE RESULTADO
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F
;-------------------------------------
;H
	
    DECFSZ  BITCOUNTER,F  ;DECREMENTA O CONTADOR DE BITS A SER RECEBIDO
    GOTO   L0             ;LE PROXIMO BIT
    
    MOVLW  .4             ;DESPREZA OS BITS DE 'ANTICODE' 1010
    MOVWF  BITCOUNTER
ACERTA
    BCF    STATUS,C
    RRF    RES3,F
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F        ;RESULTADO FICA SOMENTE EM RES2 A RES0,DESPREZA RES3
	DECFSZ BITCOUNTER,F
    GOTO   ACERTA
	


    BTFSC  FLAG1        ;TESTA SE  A PRIMEIRA OU A SEGUNDA RECEPO
	GOTO   PULA1
    MOVFW  RES2         ;SALVA A PRIMEIRA LEITURA PARA COMPARAO COM UMA SEGUNDA
    MOVWF  RES2A
    MOVFW  RES1
    MOVWF  RES1A    
    MOVFW  RES0
    MOVWF  RES0A	
    BSF   FLAG1			;SETA FLAG DE PRIMEIRA RECEPO

    GOTO  INICIO
PULA1
	BCF FLAG1          ;SEGUNDA RECEPO, COMPARA COM A PRIMEIRA
	MOVFW  RES2
    XORWF  RES2A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
    MOVFW  RES1
    XORWF  RES1A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
	MOVFW  RES0
    XORWF  RES0A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC	  ;ERRO DE RECEPO

    MOVFW  RES2
    MOVWF  RES3       ;SALVA RES2 EM RES3
    MOVLW  B'00111111'
    ANDWF  RES2,F     ;APAGA BOTES

	MOVFW  RES2      ;ELIMINA CODIGO 0X000000
    XORLW  .0
    BTFSC  STATUS,Z
    GOTO   RESETAC	  ;ERRO DE RECEPO
	MOVFW  RES1
    XORLW  .0
    BTFSC  STATUS,Z
    GOTO   RESETAC	  ;ERRO DE RECEPO
	MOVFW  RES0
 	XORLW  .0
    BTFSC  STATUS,Z
    GOTO   RESETAC	  ;ERRO DE RECEPO

    GOTO   AO       ;OK - BOA RECEPO

RESETAC
	CLRF   RES3A     ; APAGA RESULTADOS DE COMPARAO
    CLRF   RES2A
    CLRF   RES1A
	CLRF   RES0A
    GOTO INICIO




;-------------------------------------
AO
;I
    BTFSS  LRN     ;BOTO EST APERTADO?
    BSF    FLAGGR
    CALL   PPT
    SUBLW  .0
    BTFSC  STATUS,Z  ;  '0'?
    GOTO   APRENDER    ;NENHUM CONTROLE FOI  GRAVADO
MADDRESS
    MOVFW  TMP
	MOVWF  ADDRESS
    CALL   EEREAD
    XORWF  RES2,W      ;COMPARA COM RES2
    BTFSS  STATUS,Z
    GOTO   PROXIMO
    DECF   ADDRESS,F
    MOVFW  ADDRESS
    CALL   EEREAD
    XORWF  RES1,W      ;COMPARA COM RES1
    BTFSS  STATUS,Z
    GOTO   PROXIMO
	DECF   ADDRESS,F
	MOVFW  ADDRESS
    CALL   EEREAD
    XORWF  RES0,W      ;COMPARA COM RES0
    BTFSC  STATUS,Z
    GOTO ACIONAR	   ;ENCONTRADO CONTROLE NA MEMRIA
PROXIMO					;VAI PARA O PROXIMO ENDEREO DE MEMRIA PROCURAR....
    
    MOVFW   ADDRESS
    MOVWF   TMP
    MOVLW   .3
    SUBWF   TMP,F	  ;ACERTA  DE 3 EM 3 A POSIO DE BUSCA NA MEMRIA

	BTFSS  STATUS,C  
	GOTO   APRENDER 

    BTFSS   STATUS,Z
    GOTO   MADDRESS   ;VOLTA A BUSCA
   
    
APRENDER
    BTFSS  FLAGGR    ;TESTA SE BOTO 'LEARN' EST PRESSIONADO
    GOTO   INICIO    ;NO EST.
    CALL   PPT       ;EST, PEGA PONTEIRO
    MOVWF  ADDRESS   ;PEGA O ENDEREO APONTADO
	SUBLW  0X7E      ;LIMITE MAXIMO DA EEPROM (128-1 /3= 42 BOTES OU 24 CONTROLES)
    BTFSS  STATUS,C
    CLRF   ADDRESS    ;INICIA SOBREGRAVAO
    INCF   ADDRESS,F        ;SOMA 1
    MOVFW  RES0
    MOVWF  TMP		 ;COLOCA EM 'TMP'
    MOVFW  ADDRESS   ;DA O POSIO DE MEMORIA A SER GRAVADO
    CALL   EEWRITE   ;ROTINA DE ESCRITA NA EEPROM
    INCF   ADDRESS,F ;PROXIMA POSIO DE ESCRITA NA EEPROM
    MOVFW  RES1
    MOVWF  TMP
    MOVFW  ADDRESS 
    CALL   EEWRITE
    INCF   ADDRESS,F
    MOVFW  RES2
    MOVWF  TMP
    MOVFW  ADDRESS 
    CALL   EEWRITE
    MOVFW  ADDRESS
    MOVWF  TMP
    MOVLW  .0
    CALL   EEWRITE  ;GRAVA NOVO ENDEREO DE PONTEIRO
    BCF    FLAGGR
    BTFSS  LRN
    GOTO   $-1
    MOVLW  .10    ;TEMPO DE ATRASO
    CALL   DELAYM
    
    BSF   LED       ;LIGA LED
    MOVLW  .10    ;TEMPO DE ATRASO
    CALL   DELAYM
    BCF   LED       ;DESLIGA
    
ACIONAR 
;==========================================================================

    MOVFW  RES3  ;RECUPERA OS BOTES
    MOVWF  RES2 
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   MODO  RETENO 
    IFDEF RETENO
    BTFSS  RES2,7   ; SE OS DOIS BOTES ESTIVEREM ACIONADOS
    GOTO   KJ5      ; VAI TESTAR INDIVIDUALMENTE CADA BOTO
    BCF    FLAGLED2
    BTFSS  RES2,6
    GOTO   KJ6      ; VAI TESTAR INDIVIDUALMENTE CADA BOTO
    BTFSC  FLAGLED3
    GOTO   KCONT
    BTFSS  LED3     ;MUDA O ESTADO DA SAIDA LED3
    GOTO   HG1
    BCF    LED3     ;DESLIGA
    GOTO   KSET3		;NO TESTA MAIS NADA
HG1
	BSF    LED3      ;LIGA
KSET3
    BSF    FLAGLED3
    GOTO   KCONT
;--------------------------
KJ5
    BCF    FLAGLED3  
    BCF    FLAGLED1  
	BTFSC  FLAGLED2
    GOTO   KCONT
	BTFSS  LED2
    GOTO   HG2A		;NO TESTA MAIS NADA
    BCF    LED2
    GOTO   KSET2
HG2A 
    BSF    LED2		;LIGA LED2
KSET2
	BSF    FLAGLED2
    GOTO   KCONT		;NO TESTA MAIS NADA
KJ6
    BCF    FLAGLED3
    BTFSC  FLAGLED1
    GOTO   KCONT
    BTFSS  LED1
    GOTO   HG3
    BCF    LED1     ;DESLIGA LED1
    GOTO   KSET1      ;NO TESTA MAIS NADA
HG3 
    BSF    LED1     ;LIGA LED1
KSET1
	BSF    FLAGLED1
    GOTO   KCONT
    ENDIF
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;MODO PULSO
    IFDEF  PULSO  ;ACIONA UM UNICO LED (BOTO ESQ= LED1 ;BOTO DIR=LED2 ;2 BOTES=LED3)
    BTFSS  RES2,7   ; SE OS DOIS BOTES ESTIVEREM ACIONADOS
    GOTO   SJ5
	BTFSS  RES2,6
    GOTO   SJ5
    BSF    LED3   ;LIGA O LED3
    BCF    LED2
    BCF    LED1
    GOTO   SJ6    ; PULA OS OUTROS TESTES
SJ5


	BTFSS  RES2,7  ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO
	GOTO   SJ7
	BSF    LED1    ;LIGA LED1
    BCF    LED2
    BCF    LED3
    GOTO   SJ6
SJ7
	BTFSS  RES2,6  ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO
	GOTO   SJ7
	BSF    LED2    ;LIGA LED2
    BCF    LED1
    BCF    LED3
    ENDIF
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
KCONT
SJ6
    MOVLW  T_DESL_LED  ;RECARGA DO TEMPORIZADOR DE DESLIGAMENTO
    MOVWF  Y2
    MOVLW  .255
    MOVWF  Y1
   
    GOTO INICIO

;****************************************************
;PEGA PONTEIRO NA EEPROM - ULTIMO ENDEREO
PPT
    MOVLW .0
    CALL  EEREAD    ;LE  PONTEIRO DA EEPROM
    RETURN
;--------------------------------------------------------------
DELAYM     ; DELAY= 50 milisegundos X 'W'
   MOVWF  R0
XC
   CALL  AGUARDE
   DECFSZ R0,F
   GOTO XC
   RETURN

AGUARDE		; ROTINA DE ATRASO ENTRE OPERAES DE EEPROM (50 MSEG)
	MOVLW  .50
	MOVWF	R2
    CALL DELAY_1MS  ;ROTINA DE 1 MILISEGUNDOS
    DECFSZ  R2,F
    GOTO  $-2
    RETURN
DELAY_1MS
	MOVLW	.199
	MOVWF	R1
    CLRWDT
    NOP
	DECFSZ	R1,F
	GOTO $-3
	RETURN


EEWRITE

; ******* EEPROM WRITE ENABLE ******************
;endereo esta em ADDRESS
;DADOS A ESCREVER ESTA EM TMP(MSB)  


	BANK1
	movwf EEADR	
	BANK0
	MOVFW  TMP		;PEGA PRIMEIRO DADO
	BANK1
	movwf EEDATA
	bcf EECON1, EEIF	
	bsf EECON1, WREN ; enable Write\par
	movlw 0x55	
	movwf EECON2	
	movlw 0xAA	
	movwf EECON2	
	bsf EECON1, WR	
WRITE_SN_A clrwdt	
	btfsc EECON1, WR ; Write complete ?\par
	goto WRITE_SN_A	
	bcf EECON1, WREN ; disable Write\par
 	BANK0

	clrwdt	
	
ESPERA1			;DELAY ENTRE APAGAMENTOS
	CALL  AGUARDE
	RETURN



EEREAD
;endereo esta em ADDRESS
;DADOS LIDOS SERO ESCRITOS EM TMP0
        
	clrwdt	
;	MOVFW  ADDRESS
	
	BANK1
	movwf EEADR	
	bsf EECON1, RD ; do a read\par
	clrwdt
    btfsc EECON1, RD ; Read done ?\par
	goto $-1	
	movf EEDATA,W
	BANK0
	MOVWF	TMP	;RECUPERA PRIMEIRO NUMERO DA EEPROM
	clrwdt	

	RETURN
;------------------------------------------------------------------------------
APAGAEEPROM ;OK TESTADA E APROVADA
; ROTINA PARA APAGAR TODAS AS POSIOES DA EEPROM DO 16F628
	


	MOVLW 0X80		;TOTAL DE 128 + 1 BYTES DE EEPROM
	MOVWF	AUX
RET6
	CLRWDT
	MOVFW	AUX
	MOVLW   .1  ;ACERTA ENDEREO TIRANDO 1
	SUBWF	AUX,W
	BANK1
	movwf EEADR	
	MOVLW	0XFF
	movwf EEDATA
	bcf EECON1, EEIF	
	bsf EECON1, WREN ; enable Write\par
	movlw 0x55	
	movwf EECON2	
	movlw 0xAA	
	movwf EECON2	
	bsf EECON1, WR	
WRITE_SN_C clrwdt	
	btfsc EECON1, WR ; Write complete ?\par
	goto WRITE_SN_C	
	bcf EECON1, WREN ; disable Write\par
 	BANK0
	DECFSZ	AUX,F
	GOTO  ESPERA
	clrwdt	
	RETLW 0H
ESPERA			;DELAY ENTRE APAGAMENTOS
	MOVLW  .8
	MOVWF	R1
CG1
	MOVLW	.255
	MOVWF	R2
	
	DECFSZ	R2,F
	GOTO $-1
	DECFSZ	R1,F
	GOTO CG1
	GOTO RET6
    
   ORG H'2100' 
   DE  .0

     end
